<?php
// Mikrotik Freshbooks Intergration Script v1.0
//
// Jim Bouse
// jim@mobileitpro.com
// http://jimbouse.com/post/2012/10/09/FreshBooks-and-Mikrotik-Automatic-Non-Payment-Script.aspx
// October 9, 2012
//
// License: None...  Feel free to use, modify, butcher, whatever, this code.  I ask that if you add features, you send me a copy.
//
// Plug: I own and operate an WISP that uses Ubiquiti and Mikrotik equipment.  I also do consulting work and onsite assistance.

require('config.php');
require('routeros_api.class.php');
if (!$_POST) {
	// assume the remote user is here because they haven't paid.
	$mikrotik_ip_array = str_getcsv($mikrotik_ip_list_csv,",");
	foreach ($mikrotik_ip_array as $mikrotik_ip) {
		$API = new routeros_api();
		$API->debug = false;
		if ($API->connect($mikrotik_ip, $mikrotik_user, $mikrotik_pass)) {
			$API->write('/queue/simple/getall');
			$READ = $API->read(false);
			$ARRAY = $API->parse_response($READ);

			foreach( $ARRAY as $Queue ) {
				// compare to Customers array.
				if ($RemoteIP."/32" == $Queue['target-addresses']) {
					$CustomerName = $Queue['name'];
				}
			}
		}
		$API->disconnect();
	}

	if (isset($CustomerName)) {
		$xml = '<request method="client.list">';
			$xml .= '<per_page>100</per_page>';
		$xml .= '</request>';
		$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
		$pages = $result->clients['pages'];
		
		$i = 1;
		while ($i <= $pages) {
			// each page will be fetched
			$xml = '<request method="client.list">';
				$xml .= '<page>'.$i++.'</page>';
				$xml .= '<per_page>100</per_page>';
			$xml .= '</request>';
			$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
			foreach ($result -> clients[0] -> client as $row) {
				// each record in the page will be added to the array
				$first_name = $row->first_name;
				$last_name = $row->last_name;
				$name = $last_name.", ".$first_name;

				if ($name == $CustomerName) {
					$ClientID = $row->client_id;
				}
			}
		}
	} else {
		echo "<h1>Error looking up customer for IP: ".$RemoteIP."</h1><h2>Please contact ".$CompanyName." - ".$CompanyPhone."</h2>";
		die;
	}


	if (isset($ClientID)) {
		$xml = '<request method="client.get">';
			$xml .= '<client_id>'.$ClientID.'</client_id>';
		$xml .= '</request>';
		
		$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
		$fname = $result->client[0]->first_name;
		$lname = $result->client[0]->last_name;
		$link = $result->client[0]->links->client_view;
	}
	?>
	<HTML>
		<head>
			<title>Account Overdue</title>
		</head>
		<body>
			<center>
			<h1>Internet Account Overdue</h1>
			<table width="800px">
				<tr>
					<td valign="middle"><img src="images/500px-Stop_sign_MUTCD.svg.png" style="width:250px;"></td>
					<td valign="top" style="font-size:1.5em;padding-left:10px;">
						Our records indicate that your internet accout is overdue.<br><br>
						Based on your IP address of: <b><?php echo $RemoteIP; ?></b>,<br>
						the account holder on file is <b><?php echo $fname; ?> <?php echo $lname; ?></b>.<br><br>
						If this information is correct,<br>
						<b><a href="<?php echo $link; ?>">Click Here</a></b> to pay your account online.<br><br>
						Once your account is brought current, serivce is immediately, and automatically, restored.<hr>
						If this information is incorrect, please contact us so we can get it sorted out.<br><br>
						Thank You,<br>
						<?php echo $CompanyName; ?></br>
						<?php echo $CompanyPhone; ?></br>
						
					</td>
				</tr>
			</table>
			</center>
		</body>
	</html>
	
<?php

} else {
	// assume this is the FreshBooks CallBack
	switch ($_POST['name']) {
		case "callback.verify":
			$xml = '<request method="callback.verify">';
				$xml .= '<callback>';
					$xml .= '<callback_id>'.$_POST['object_id'].'</callback_id>';
					$xml .= '<verifier>'.$_POST['verifier'].'</verifier>';
				$xml .= '</callback>';
			$xml .= '</request>';
			PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml);
			break;
		case "invoice.pastdue.2":
			$xml = '<request method="invoice.get">';
				$xml .= '<invoice_id>'.$_POST['object_id'].'</invoice_id>';
			$xml .= '</request>';
			
			$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
			$fname = $result->invoice[0]->first_name;
			$lname = $result->invoice[0]->last_name;
			$link = $result->invoice[0]->links->client_view;
			
			$mikrotik_ip_array = str_getcsv($mikrotik_ip_list_csv,",");
			foreach ($mikrotik_ip_array as $mikrotik_ip) {
				$API = new routeros_api();
				$API->debug = false;
				if ($API->connect($mikrotik_ip, $mikrotik_user, $mikrotik_pass)) {
					$API->write('/queue/simple/getall');
					$READ = $API->read(false);
					$ARRAY = $API->parse_response($READ);

					// walk through the results and look for the name specified above.
					foreach( $ARRAY as $Queue ) {
						if ($Queue['name'] == $lname.", ".$fname) {
							if (substr($Queue['target-addresses'], -3) == "/32") {
								$ip_subnet = $Queue['target-addresses'];
								$ip = substr($Queue['target-addresses'], 0, -3);
							}
						}
					}
					
					// add the entry into the NonPayment list
					$API->write("/ip/firewall/address-list/add", false);
					$API->write("=list=NonPayment", false);
					$API->write("=address=".$ip_subnet, false);
					$API->write("=comment=".$lname.", ".$fname." added ".date(DATE_RFC822));
					$READ = $API->read(false);

					$API->disconnect();
					if ($log == TRUE) {
						$fp = fopen('request.log', 'a');
						fwrite($fp, "Added ".$lname.", ".$fname." to the non payment list.");
						fclose($fp);
					}
				}
			}
			
			break;	
			
		case "payment.create":
			// query for payment info
			$xml = '<request method="payment.get">';
				$xml .= '<payment_id>'.$_POST['object_id'].'</payment_id>';
			$xml .= '</request>';
			$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
			$invoice_id = $result->payment[0]->invoice_id;
			
			// if payment info is found, query for invoice info
			$xml = '<request method="invoice.get">';
				$xml .= '<invoice_id>'.$invoice_id.'</invoice_id>';
			$xml .= '</request>';
			$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
			$fname = $result->invoice[0]->first_name;
			$lname = $result->invoice[0]->last_name;
			$link = $result->invoice[0]->links->client_view;
			$status = $result->invoice[0]->status;
			
			// if the status is paid, fetch their IP then remove their account from the block list.
			if ($status == "paid") {
				$mikrotik_ip_array = str_getcsv($mikrotik_ip_list_csv,",");
				foreach ($mikrotik_ip_array as $mikrotik_ip) {
					$API = new routeros_api();
					$API->debug = false;

					if ($API->connect($mikrotik_ip, $mikrotik_user, $mikrotik_pass)) {

						$API->write('/queue/simple/getall');

						$READ = $API->read(false);
						$ARRAY = $API->parse_response($READ);

						// walk through the results and look for the name specified above.
						foreach( $ARRAY as $Queue ) {
							if ($Queue['name'] == $lname.", ".$fname) {
								if (substr($Queue['target-addresses'], -3) == "/32") {
									$ip_subnet = $Queue['target-addresses'];
									$ip = substr($Queue['target-addresses'], 0, -3);
								}
							}
						}
						
						$API->write('/ip/firewall/address-list/getall');

						$READ = $API->read(false);
						$ARRAY = $API->parse_response($READ);
						
						// walk through the results and look for the IP found above.  If found, remove from list
						foreach( $ARRAY as $AddressList ) {
							
							if ($AddressList['address'] == $ip) {
								$id = $AddressList['.id'];
								$API->write("/ip/firewall/address-list/remove", false);
								$API->write("=numbers=".$id);
								$READ = $API->read(false);
							}
						}

						$API->disconnect();
						if ($log == TRUE) {
							$fp = fopen('request.log', 'a');
							fwrite($fp, "Removed ".$lname.", ".$fname." from the non payment list.");
							fclose($fp);
						}
					}
				}
			}
			break;
			
	}
}
?>